// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package model

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// MovieGrpcClient is the client API for MovieGrpc service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type MovieGrpcClient interface {
	Search(ctx context.Context, in *SearchMovieRequest, opts ...grpc.CallOption) (*SearchMovieResponse, error)
	GetById(ctx context.Context, in *DetailRequest, opts ...grpc.CallOption) (*MovieDetailResponse, error)
}

type movieGrpcClient struct {
	cc grpc.ClientConnInterface
}

func NewMovieGrpcClient(cc grpc.ClientConnInterface) MovieGrpcClient {
	return &movieGrpcClient{cc}
}

func (c *movieGrpcClient) Search(ctx context.Context, in *SearchMovieRequest, opts ...grpc.CallOption) (*SearchMovieResponse, error) {
	out := new(SearchMovieResponse)
	err := c.cc.Invoke(ctx, "/model.Movie_grpc/Search", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *movieGrpcClient) GetById(ctx context.Context, in *DetailRequest, opts ...grpc.CallOption) (*MovieDetailResponse, error) {
	out := new(MovieDetailResponse)
	err := c.cc.Invoke(ctx, "/model.Movie_grpc/GetById", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// MovieGrpcServer is the server API for MovieGrpc service.
// All implementations must embed UnimplementedMovieGrpcServer
// for forward compatibility
type MovieGrpcServer interface {
	Search(context.Context, *SearchMovieRequest) (*SearchMovieResponse, error)
	GetById(context.Context, *DetailRequest) (*MovieDetailResponse, error)
	mustEmbedUnimplementedMovieGrpcServer()
}

// UnimplementedMovieGrpcServer must be embedded to have forward compatible implementations.
type UnimplementedMovieGrpcServer struct {
}

func (UnimplementedMovieGrpcServer) Search(context.Context, *SearchMovieRequest) (*SearchMovieResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Search not implemented")
}
func (UnimplementedMovieGrpcServer) GetById(context.Context, *DetailRequest) (*MovieDetailResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetById not implemented")
}
func (UnimplementedMovieGrpcServer) mustEmbedUnimplementedMovieGrpcServer() {}

// UnsafeMovieGrpcServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to MovieGrpcServer will
// result in compilation errors.
type UnsafeMovieGrpcServer interface {
	mustEmbedUnimplementedMovieGrpcServer()
}

func RegisterMovieGrpcServer(s grpc.ServiceRegistrar, srv MovieGrpcServer) {
	s.RegisterService(&MovieGrpc_ServiceDesc, srv)
}

func _MovieGrpc_Search_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SearchMovieRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MovieGrpcServer).Search(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/model.Movie_grpc/Search",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MovieGrpcServer).Search(ctx, req.(*SearchMovieRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _MovieGrpc_GetById_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DetailRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MovieGrpcServer).GetById(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/model.Movie_grpc/GetById",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MovieGrpcServer).GetById(ctx, req.(*DetailRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// MovieGrpc_ServiceDesc is the grpc.ServiceDesc for MovieGrpc service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var MovieGrpc_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "model.Movie_grpc",
	HandlerType: (*MovieGrpcServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Search",
			Handler:    _MovieGrpc_Search_Handler,
		},
		{
			MethodName: "GetById",
			Handler:    _MovieGrpc_GetById_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "movie.proto",
}
